#include <random>
#include <thread>
#include <chrono>
#include <math.h>
#include <numbers>

#include "Pepravka.h"
#include "ukonovatel.h"
#include "Dodavatel.h"

std::mt19937 genertor;
std::uniform_int_distribution<int> genertor_int;
std::uniform_real_distribution<double> genertor_double;

void Dodavatel()
{
	while (!konec)
	{
		double gama1 = genertor_double(genertor);
		double gama2 = genertor_double(genertor);
		auto costheta = 2 * gama1 - 1;
		auto sintheta = sqrt(1 - costheta * costheta);
		auto f = 2 * numbers::pi_v<double> *gama2;
		Bod bod{ sintheta * sin(f), sintheta * cos(f), costheta };
		pepravka.pijmi(bod);
		std::this_thread::sleep_for(std::chrono::milliseconds(genertor() % 20));
	}
}

std::string Bod::text()
{
	return "("s + to_string(x) + ", "s + to_string(y) + ", "s + to_string(z) + ")"s;
}
