#include <iostream>
#include <thread>

using namespace std;

thread_local 
int i = 0;

void zm_hodnotu_i(int nov_hodnota)
{
	i = nov_hodnota;
}

void vypi_hodnotu()
{
	cout << i;
}

void tlo_podprocesu(int hodnota)
{
	zm_hodnotu_i(hodnota);
	this_thread::sleep_for(10ms);
	i++;
	vypi_hodnotu();
}

int main()
{
	i = 9;
	thread t1{ tlo_podprocesu, 1 };
	thread t2{ tlo_podprocesu, 2 };
	thread t3{ tlo_podprocesu, 3 };

	t1.join();
	t2.join();
	t3.join();
	vypi_hodnotu();
}