#include <string>
#include <thread>
#include <chrono>
#include <future>
#include <iostream>
#include <stdlib.h>

#include "eitel.h"

using namespace std;
using namespace std::chrono;
using namespace std::this_thread;

promise<int> pslib_vsledku;

int poetDam = 13;

class sloit_vpoet
{
	dmy::eitel eitel;
public:
	sloit_vpoet(int poetDam) : eitel(poetDam){}
	void operator()()
	{
		string text = "em lohu " + to_string(poetDam) + " dam\n";
		cout << text;
		eitel.najdiVechnaeen();
		cout << "Odeslm vsledek\n";
		pslib_vsledku.set_value(eitel.getPoetNalezencheen());
	}
};

void dlej_si_sv()
{
	cout << "Dlm si sv\n";
	sleep_for(300ms);
}

template<class T>
bool hotovo(future<T>& budouc_vsledek)
{
	return budouc_vsledek.wait_for(0us) == future_status::ready;
}

sloit_vpoet vpoet(poetDam);

int main()
{
	system("CHCP 1250 > NUL");
	thread vlkno{ vpoet };
	future<int> vsledek_vpotu = pslib_vsledku.get_future();
	while (!hotovo(vsledek_vpotu))
	{
		dlej_si_sv();
	}
	cout << "loha " << poetDam << " dam m " << vsledek_vpotu.get() << " een." << endl;
	vlkno.join();
}