#include <thread>
#include <iostream>
#include <mutex>
#include <condition_variable>
#include <stdlib.h>

using namespace std;

int poet = 3;

const char* ver1 = "Koka leze drou\n";
const char* ver2 = "Pes oknem\n";

condition_variable koka;
condition_variable pes;

mutex mtx;

bool vypsna_koka = false;
bool vypsn_pes = true;

void vypi_koku(const char* txt)
{
	for (int i = 0; i < poet; i++)
	{
		unique_lock<mutex> zmek(mtx);
		while (!vypsn_pes)
		{
			pes.wait(zmek);
		}
		cout << txt;
		vypsna_koka = true;
		vypsn_pes = false;
		koka.notify_one();
	}
}

void vypi_psa(const char* txt)
{
	for (int i = 0; i < poet; i++)
	{
		unique_lock<mutex> zmek(mtx);
		while (!vypsna_koka)
		{
			koka.wait(zmek);
		}
		cout << txt;
		vypsna_koka = false;
		vypsn_pes = true;
		pes.notify_one();
	}
}

int main()
{
	system("CHCP 1250 > NUL");
	cout << "Pjme vichni sborem:" << endl;
	thread t1{ vypi_koku, ver1 };
	thread t2{ vypi_psa, ver2 };
	t1.join();
	t2.join();
	cout << "Nebude-li pret, nezmoknem" << endl;
}