#include <string>
#include <thread>
#include <chrono>
#include <future>
#include <iostream>
#include <stdlib.h>
#include <stdexcept>

#include "eitel.h"

using namespace std;
using namespace std::chrono;
using namespace std::this_thread;

promise<int> pslib_vsledku;

int poetDam = 3;

class sloit_vpoet
{
	
public:
	sloit_vpoet() {}
	void operator()()
	{
		try
		{
			dmy::eitel eitel(poetDam);
			string text = "em lohu " + to_string(poetDam) + " dam\n";
			cout << text;
			eitel.najdiVechnaeen();
			cout << "Odeslm vsledek\n";
			pslib_vsledku.set_value(eitel.getPoetNalezencheen());
		}
		catch (...)
		{
			try
			{
				pslib_vsledku.set_exception(current_exception());
			}
			catch (...) {
				// mysln przdn obsluha
			}
		}
	}
};

void dlej_si_sv()
{
	cout << "Dlm si sv\n";
	sleep_for(300ms);
}

template<class T>
bool hotovo(future<T>& budouc_vsledek)
{
	return budouc_vsledek.wait_for(0us) == future_status::ready;
}

sloit_vpoet vpoet;

int main()
{
	system("CHCP 1250 > NUL");
	thread vlkno{ vpoet };
	future<int> vsledek_vpotu = pslib_vsledku.get_future();
	while (!hotovo(vsledek_vpotu))
	{
		dlej_si_sv();
	}
	try
	{
		cout << "loha " << poetDam << " dam m " << vsledek_vpotu.get() << " een." << endl;
	}
	catch (const exception& vjimka)
	{
		cout << "Vjimka v podprocesu: " << vjimka.what() << endl;
	}
	vlkno.join();
}